// Объект Control
function g_sControl(in_gui){
   var l_sServers = [];
   var l_sPlayers = [];
   var l_sContent = [];
   var l_sSelect = [];
   var l_sPlayselect = [];   
   var l_sPlayer;
   var l_sDuration;
   var l_sPosition = 0;   
   var l_sType;            // текущая категория
   var l_sPtype;           // предыдущая категория (previous)
   var l_sHistory = [];
   var l_sList;
   var l_sPlayersList;
   var l_sServersList;
   var l_sTrack;
   var l_sArtist;
   var l_sAlbum;
   var l_sArt;
   var l_sPlaylist;
   var l_sPltracks;
   var l_sPlay;   
   var l_sVolume;
   var l_sPercent;
   var l_sMute;
   var l_sShuffle;
   var l_sRepeat;
   var l_sTimeline;
   var l_sTimeleft;
   var l_sTimeright;
   var l_sFolder;
   var l_sLetters = [];
   var l_sCurrent;
   var l_sLastplayer = 0;
   var l_sContenticon;
   var l_sRemove;
   var l_sAbdate = true;
   // элемент листа на который нажали для позиционирования списка после Back
   var l_sPrevListItem = -1;
   var l_sPostioning = false;   
   // количество видимых элементов в списке
   var l_sListItemsCount = Math.round(GetItem(in_gui.l_sContent).Height / IR.GetPopup(in_gui.l_sTemplateName).Height);
   // Карта различных типов контента
   var l_sMap = {
      artist:        {command: "artists",    name: "Artists"},
      album:         {command: "albums",     name: "Albums",   tags: "alj"},
      genre:         {command: "genres",     name: "Genres"},
      title:         {command: "titles",     name: "Songs",    tags: "ac sort%3Aalbumtrack"},
      year:          {command: "years",      name: "Years" },
      playlist:      {command: "playlists",  name: "Playlists"},
      radio:         {command: "radios",     name: "Radios"},
      browse:        {command: " items",     name: "Radios"},
      musicfolder: {command: "musicfolder",    name: "Folders"},
      search:        {command: "search",     name: "Search"},
      random:        {command: "random",     name: "Random Mix"},
      randomgenre:   {command: "randomplaygenrelist", name: "Choose genres"},
      pltrack:       {command: "playlists tracks",    name: "Tracks", tags: "ac"},
      favorit:       {command: "favorites items",     name: "Favorites"}
   }; 
   // Каталог поиска
   var l_sSearch = [
      "",
      "artist",
      "album",
      "title",
      "playlist",
      "browse"
   ];
   // Каталог микса
   var l_sRandom = [
      {},
      {command: "tracks",        name: "Random songs"},
      {command: "albums",        name: "Random albums"},
      {command: "contributors",  name: "Random artist"},
      {command: "year",          name: "Random years"}
   ];
   var date = new Date();
   var date2 = new Date();
   var l_sPlugin;
   var playlist_id;
   var artist_id;
   // Конструктор
   Init();
   // Начальная инициализация
   function Init(){      
      // Список плееров
      l_sPlayersList = GetItem(in_gui.l_sPlayerSelectList);
      IR.AddListener(IR.EVENT_ITEM_SELECT, l_sPlayersList, function(item, subItem){
         IR.HidePopup(in_gui.l_sSelect);
         SelectPlayer(item);
      });
      // Список серверов
      l_sServersList = GetItem(in_gui.l_sServerSelectList);
      IR.AddListener(IR.EVENT_ITEM_SELECT, l_sServersList, function(item, subItem){
         if(subItem == 6){
            l_sServers[item].Disconnect();
            l_sServers.splice(item, 1);
            SaveServers();
            UpdateServers();
            UpdatePlayers();
         }
      });
      // Список контента
      l_sList = GetItem(in_gui.l_sContent);
      IR.AddListener(IR.EVENT_ITEM_SELECT, l_sList, function (item, subItem){  

         //IR.Log("> lsType " + l_sType + ">>>" + JSON.Stringify(l_sContent[item]))

         //IR.Log("item"+ item + "" + "subitem" + subItem);
         l_sPrevListItem = item;
         l_sPostioning = false;
         if(l_sContent[item] == 0){
            // Окно поиска
            IR.ShowPopup(in_gui.l_sLetters);
         } 
         else if(subItem == 5){
            // Пометить
            l_sSelect[item] ^= 1;
            l_sList.CreateItem(item, 0, {FillColor: (l_sSelect[item] ? in_gui.l_sContentCol1 : in_gui.l_sContentCol0)});      
            l_sList.CreateItem(item, 5, {Value: l_sSelect[item]}); 
            if(l_sType == "randomgenre"){
               l_sPlayer.server.Request(l_sPlayer.id + " randomplaychoosegenre "+ l_sContent[item] + ' ' + l_sSelect[item]);
            }
         } 
         else {       
            //switch(ptype)  
            switch(l_sType){
	
            case "artist":
               artist_id = l_sContent[item].id;
               UpdateContent("album", "artist_id%3A" + artist_id);
               break;
            case "album":
               UpdateContent("title", "album_id%3A" + l_sContent[item].id + (artist_id ? (" artist_id%3A" + artist_id) : ""));
               break;
            case "genre":
               UpdateContent("artist", "genre_id%3A" + l_sContent[item].id);
               break;
            case "musicfolder":
			   switch(l_sContent[item].type){
					 case "folder":
					UpdateContent("musicfolder", "folder_id%3A" + l_sContent[item].id);
					 break;
					 case "track":
                     l_sPlayer.server.Request(l_sPlayer.id + " playlistcontrol cmd%3Aload track_id%3A" + l_sContent[item].id);
					 break;
					 case "playlist":
					l_sPlayer.server.Request(l_sPlayer.id + " playlistcontrol cmd%3Aload playlist_id%3A" + l_sContent[item].id);
					break;
			   }
               break;
            case "year":
               UpdateContent("album", "year%3A" + l_sContent[item].id);
               break;
            case "playlist":
               playlist_id = l_sContent[item].id;
               UpdateContent("pltrack", "playlist_id%3A" + playlist_id);
               break;
            case "title":
               //prev.type
               if(l_sHistory[0].l_sType == "search"){
                  l_sPlayer.server.Request(l_sPlayer.id + " playlist clear");
                  var command = l_sPlayer.id + " playlistcontrol cmd%3Aload";
                  l_sPlayer.server.Request(command + " track_id%3A" + l_sContent[item].id);
               }
               else {
                  l_sPlayer.server.Request("songinfo 0 3 track_id%3A" + l_sContent[item].id +  " tags%3Ae", function(response){
                     var albumid = response.substring(response.indexOf("album_id%3A"));
                     l_sPlayer.server.Request(l_sPlayer.id + " playlistcontrol cmd%3Aload " + albumid + " play_index%3A" + item);
                  });
               }
               break;
            case "pltrack":
               // var playlist_id = l_sContent[item].id; ???
               l_sPlayer.server.Request(l_sPlayer.id + " playlistcontrol cmd%3Aload playlist_id%3A" + playlist_id + " play_index%3A" + item);
               break;
            case "favorit":
               if(l_sContent[item].audio == 1)
                  l_sPlayer.server.Request(l_sPlayer.id + " favorites playlist play item_id%3A"+ l_sContent[item].id);
               else {
                  l_sPlugin = "picks"; // выставляем плагин иначе он undefined, если не был в радио
                  UpdateContent("browse", "item_id%3A" + l_sContent[item].id + " want_url%3A1");
               }
               break;
            case "radio":
               l_sPlugin = l_sContent[item].id;
               UpdateContent("browse");
               break;
            case "browse":
               if(l_sContent[item].audio == 1)
                  l_sPlayer.server.Request(l_sPlayer.id + ' ' + l_sPlugin + " playlist play item_id%3A"+ l_sContent[item].id);
               else
                  UpdateContent("browse", "item_id%3A" + l_sContent[item].id + " want_url%3A1");
               break;
            case "search":
               //IR.HidePopup(in_gui.search);
               l_sPlugin = "search";
               var text = GetItem(in_gui.l_sFilter).Text;
               if(text){ 
                  var str = TranslitRusString(text);   // грязный хак
                  UpdateContent(l_sSearch[item], "search%3A" + str);
               } 
               else{
                  GetItem(in_gui.l_sSearchClose).Visible = true;
                  GetItem(in_gui.l_sSearchClose).Enable = true;
                  GetItem(in_gui.l_sSearchOpen).Visible = false;
                  GetItem(in_gui.l_sSearchOpen).Enable = false;
               }
               break; 
            case "random":
               l_sPlayer.server.Request(l_sPlayer.id + " randomplay "+ l_sRandom[item].command);
               break;
               }
            }
         }); 
         // Текущий каталог
         l_sFolder = GetItem(in_gui.l_sType);
         // Фильтр списка
         IR.AddListener(IR.EVENT_ITEM_CHANGE, GetItem(in_gui.l_sFilter), function(){
            if(l_sType != "search")
               l_sList.Filter = GetItem(in_gui.l_sFilter).Text.toLowerCase();
         });
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sSearchClose), function(){
            l_sList.Filter = "";
         });
         // Выбор типа контента
         var popup = IR.GetPopup(in_gui.l_sContentSelect);
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectAlbum), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("album");
         });
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectMusicfolder), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("musicfolder");
         });	
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectArtist), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("artist");
         });	
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectGenre), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("genre");
         });	
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectYear), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("year", "hasAlbums%3A1");
         });	      
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectRadio), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("radio");   
         });	      
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectSearch), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("search");
            IR.ShowPopup(in_gui.search);
         });	      
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectPlaylist), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("playlist");
         });	      
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectFavorites), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("favorit");
         });	      
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sContentSelectRandom), function(){
            artist_id = undefined;
            l_sHistory = [];
            UpdateContent("random");
         });	      
         // Иконка содержимого
         l_sContenticon = GetItem(in_gui.l_sContenticon);     
         // Кнопка назад
         l_sBack = GetItem(in_gui.l_sBack);
         IR.AddListener(IR.EVENT_ITEM_RELEASE, l_sBack, function(){
            l_sPostioning = true;
            // показываем крестик около окна поиска. так делается в дизайне
            GetItem(in_gui.l_sSearchClose).Visible = true;
            GetItem(in_gui.l_sSearchClose).Enable = true;
            GetItem(in_gui.l_sSearchOpen).Visible = false;
            GetItem(in_gui.l_sSearchOpen).Enable = false;
            if(l_sHistory.length > 1){
               l_sHistory.pop();
               var l_sPrev = l_sHistory.pop();
               UpdateContent(l_sPrev.type, l_sPrev.l_sFilter);
            }   
         });
         // Информация о композиции
         l_sTrack = GetItem(in_gui.l_sTrack);
         l_sArtist = GetItem(in_gui.l_sArtist);
         l_sArt = GetItem(in_gui.l_sCover);
         l_sAlbum = GetItem(in_gui.l_sAlbum);
         // Кнопка Play
         l_sPlay = GetItem(in_gui.l_sPlay);
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sPlay, function(){
            l_sPlayer.server.Request(l_sPlayer.id + " pause");
         });	
         // Кнопка Next
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sNext), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " playlist index +1");         
         });
         // Кнопка Previous
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sPrev), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " playlist index -1");
         });   
         // Плейлист
         l_sPlaylist = GetItem(in_gui.l_sPlaylist);
         IR.AddListener(IR.EVENT_ITEM_SELECT, l_sPlaylist, function(item, subItem){
            if(subItem == 5){
               // Пометить
               l_sPlayselect[item] ^= 1;
               l_sPlaylist.CreateItem(item, subItem, {Value: l_sPlayselect[item]});
               GetItem(in_gui.l_sPlaylist).SetPosition(item); 
                 
            } 
            else {
            // Проигрывание 
            l_sAbdate = false;
            IR.SetTimeout(3000, function(){l_sAbdate = true});
            l_sPlayer.server.Request(l_sPlayer.id + " playlist index " + item)
            //l_sPlayer.server.Request(l_sPlayer.id + " playlist index " + item);  
            }
         });
         // Количество треков
         l_sPltracks = GetItem(in_gui.l_sPltracks);
         // Кнопка добавить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sAdd), function(){
            AddToPlaylist("add");
         });
         // Кнопка заменить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sReplace), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " playlist clear");   
            AddToPlaylist("add");
            l_sPlayer.server.Request(l_sPlayer.id + " playlist index 0");
         });	
         // Кнопка вставить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sInsert), function(){
            AddToPlaylist("insert");
         });	
         // Кнопка добавить в избранное
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sFavorite), function(){
            AddToFavorites();
         });	
         // Кнопка удалить
         l_sRemove = GetItem(in_gui.l_sRemove);
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sRemove, function(){
            switch(l_sType){
         case "favorit":
            DeleteFromFavorites();
            break;
         case "playlist":
            DeletePlaylists();
            break;
            }
         });	
         // Кнопка очистить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sClear), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " playlist clear");   
         });	  
         // Кнопка удалить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sDeleteb), function(){
            for(var i = l_sPlayselect.length; i >= 0; --i)
               if(l_sPlayselect[i]) 
                  l_sPlayer.server.Request(l_sPlayer.id + " playlist delete "+ i);   
         });
         // Кнопка сохранить
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sSavepl), function(){
            var name = GetItem(in_gui.l_sPlname).Text.replace(/ /g, "%20");
            l_sPlayer.server.Request(l_sPlayer.id + " playlist save " + name);   
            if(l_sType == "playlist") {
               IR.SetTimeout(500, function() {
               l_sHistory = [];
               UpdateContent("playlist");
               });         
            }
         });      
         // Уровень громкости звука
         l_sPercent = GetItem(in_gui.l_sPercent);
         l_sVolume = GetItem(in_gui.l_sVolume);
         IR.AddListener(IR.EVENT_ITEM_RELEASE, l_sVolume, function(){
            l_sPercent.Text = l_sVolume.Value + '%';
            l_sPlayer.server.Request(l_sPlayer.id + " mixer volume " + l_sVolume.Value);         
         });
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sPlus), function(){
            l_sVolume.Value += 5;
            l_sPercent.Text = l_sVolume.Value + '%';
            l_sPlayer.server.Request(l_sPlayer.id + " mixer volume " + l_sVolume.Value);         
         });
         IR.AddListener(IR.EVENT_ITEM_HOLD, GetItem(in_gui.l_sPlus), function(){
            l_sVolume.Value += 3;
            l_sPercent.Text = l_sVolume.Value + '%';         
            l_sPlayer.server.Request(l_sPlayer.id + " mixer volume " + l_sVolume.Value);         
         });
         IR.AddListener(IR.EVENT_ITEM_PRESS, GetItem(in_gui.l_sMinus), function(){
            l_sVolume.Value -= 5;
            l_sPercent.Text = l_sVolume.Value + '%';         
            l_sPlayer.server.Request(l_sPlayer.id + " mixer volume " + l_sVolume.Value);         
         });	
         IR.AddListener(IR.EVENT_ITEM_HOLD, GetItem(in_gui.l_sMinus), function(){
            l_sVolume.Value -= 3;
            l_sPercent.Text = l_sVolume.Value + '%';         
            l_sPlayer.server.Request(l_sPlayer.id + " mixer volume " + l_sVolume.Value);         
         });
         l_sMute = GetItem(in_gui.l_sMute);
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sMute, function(){
            l_sPlayer.server.Request(l_sPlayer.id + " mixer muting " + l_sMute.Value);
         });
         // Режимы воспроизведения
         l_sShuffle = GetItem(in_gui.l_sShuffle);
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sShuffle, function(){
            if(l_sShuffle.State++ == 1) l_sShuffle.State = 0;
            l_sPlayer.server.Request(l_sPlayer.id + " playlist shuffle " + l_sShuffle.State);         
         });
         l_sRepeat = GetItem(in_gui.l_sRepeat);
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sRepeat, function(){
            if(l_sRepeat.State++ == 1) l_sRepeat.State = 0;
            l_sPlayer.server.Request(l_sPlayer.id + " playlist repeat " + l_sRepeat.State);
         }); 
         // Позиция воспроизведения
         l_sTimeleft = GetItem(in_gui.l_sTimeleft);
         l_sTimeright = GetItem(in_gui.l_sTimeright);
         l_sTimeline = GetItem(in_gui.l_sTimeline);
         // до момента прихода duration
         l_sTimeleft.Visible = false;
         l_sTimeline.Enable = false;
         IR.AddListener(IR.EVENT_ITEM_PRESS, l_sTimeline, function(){
            l_sTimeline = GetItem(in_gui.l_sTimeline); 
            l_sPosition = l_sTimeline.Value / 100 * l_sDuration;
            l_sPlayer.server.Request(l_sPlayer.id + " time " + l_sPosition);
         });	      
         // Всплывающее окно поиска
         var popup = IR.GetPopup(in_gui.l_sLetters);
         for(var i = 65; i < 91; i++){
            var item = popup.GetItem(String.fromCharCode(i));
            l_sLetters[i] = item;
            IR.AddListener(IR.EVENT_ITEM_PRESS, item, function(){
               l_sList.SetPosition(this.id);
               IR.HidePopup(in_gui.l_sLetters);
            }, item);
         }
         // Кнопка добавить сервер
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sServerSelectAdd), function(){
            var host = GetItem(in_gui.l_sServerSelectHost).GetState(0).Text;
            if(host){
               var sbox = new SqueezeBox(host);
               l_sServers.push(sbox);
               sbox.Online = Online;
               sbox.Offline = Offline;            
               sbox.Connect();
               SaveServers();
               UpdateServers(); 
            }         
         });
         // Выбор жанров для случайного микса
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sChoosegenres), function(){
            UpdateContent("randomgenre");
         });
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sSelectall), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " randomplaygenreselectall 1");
            UpdateContent("randomgenre");
            if(l_sHistory.length > 1){
               l_sHistory.pop();
               var l_sPrev = l_sHistory.pop();
               UpdateContent(l_sPrev.type, l_sPrev.l_sFilter);
            }    
         });
         IR.AddListener(IR.EVENT_ITEM_RELEASE, GetItem(in_gui.l_sSelectnone), function(){
            l_sPlayer.server.Request(l_sPlayer.id + " randomplaygenreselectall 0");
            UpdateContent("randomgenre");
            if(l_sHistory.length > 1){
               l_sHistory.pop();
               var l_sPrev = l_sHistory.pop();
               UpdateContent(l_sPrev.type, l_sPrev.l_sFilter);
            }   
         });
         // Действия каждый цикл   
         LoadServers();
         UpdateServers();
         // Выбор первого плеера
         //IR.SetTimeout(2000, function() { SelectPlayer(0); });
         //IR.SetTimeout(2000, function() { SelectPlayerId("00:ff:98:49:5c:c8"); });
      }
      // Обновить список плееров
      function UpdatePlayers(){
         l_sPlayersList.Clear();
         l_sPlayers.length = 0;
         for(var i = 0; i < l_sServers.length; ++i)
            l_sServers[i].Request("players 0 10", function(server){
               return function(response){
                  var param;
                  response = response.split(' ');			
                  while(param = response.shift()){
                  if(param.indexOf("playerid%3A") == 0){
                     l_sPlayers.push({id: param.substring(11), server: server});
                  } 
                  else 
                  if(param.indexOf("name%3A") == 0){
                     var name = IR.UrlDecode(param.substring(7));
                     var idx = l_sPlayers.length-1;
                     l_sPlayers[idx].name = name;
                     l_sPlayersList.CreateItem(idx, 3, {Text: name});
                     if(idx == l_sLastplayer) 
                        SelectPlayer(l_sLastplayer);
                  }
                  }
               }
            }(l_sServers[i]));   
      }
      //Обновить состояние плеера
      function UpdatePlayer(response){
         var param, id;
         if (l_sAbdate)
            l_sPlaylist.Clear();
         l_sPlayselect.length = 0;
         l_sCurrent = undefined;
         var url = "http://" + l_sPlayer.server.host + ":" + in_gui.covers_port + "/music/";
         URLOLO = "http://" + l_sPlayer.server.host + ":9000/music/current/cover640x640";
         IR.GetPopup("Squeezebox_Main").GetItem("Cover 1").GetState(0).Image = "http://" + l_sPlayer.server.host + ":9000/music/current/cover640x640" 
         response = response.split(' ');			
      while(param = response.shift()){
         param = param.split("%3A");
      switch(param[0]){
      case "mode":
         l_sPlay.Value = (param[1] == "play") ? 1 : 0;
         break;
      case "playlist%20repeat":
         l_sRepeat.State = parseInt(param[1]);
         break;
      case "playlist%20shuffle":
         l_sShuffle.State = parseInt(param[1]);
         break;
      case "mixer%20volume":
         l_sVolume.Value = param[1];
         l_sPercent.Text = l_sVolume.Value + '%';            
         l_sMute.Value = (param[1] < 0) ? 1 : 0;
         break;
      case "playlist_cur_index":
         l_sCurrent = parseInt(param[1]);
       //  IR.Log("l_sCurrent      =" + l_sCurrent); 
         break;
      case "playlist%20index":
         id = parseInt(param[1], 10);
         break;
      case "title":
       if (l_sAbdate)
            l_sPlaylist.CreateItem(id, 2, {Text: IR.UrlDecode(param[1])});
         break;
      case "artist":
       if (l_sAbdate)
         l_sPlaylist.CreateItem(id, 3, {Text: IR.UrlDecode(param[1])});
         break;
      case "coverid":
       if (l_sAbdate)
         l_sPlaylist.CreateItem(id, 4, {Image: url + param[1] + "/cover64x64"});
         break;
      case "time":
         l_sPosition = parseFloat(param[1]);
         break;
      case "duration":{
            l_sDuration = parseFloat(param[1]);
            if(typeof l_sDuration == 'undefined'){
               l_sTimeleft.Visible = false;
               l_sTimeline.Enable = false;
            }
            else{
               l_sTimeleft.Visible = true;
               l_sTimeline.Enable = true;
            }
            break;
      }
      case "playlist_tracks":
         if(param[1] == 0){
            l_sPosition = 0;
            l_sDuration = 0;
            l_sTimeline.Value = 0;
            l_sTimeleft.Text = "";
            l_sTimeright.Text = "";
            l_sPltracks.Text = "";
         } 
         else {
            l_sPltracks.Text = '(' + (l_sCurrent + 1) + ' of ' + param[1] + ')';
         }
         break;
      case "current_title":
         var title = IR.UrlDecode(param[1]);
         l_sAlbum.Text = title;
        // IR.Log(title);
         break;
      }
      }
      // Запрашиваем информацию о текущем треке
      l_sPlayer.server.Request(l_sPlayer.id + " artist ?", function(response){
         l_sArtist.Text = IR.UrlDecode(response);
      });
      l_sPlayer.server.Request(l_sPlayer.id + " title ?", function(response){
         l_sTrack.Text = IR.UrlDecode(response);
      });
      l_sPlayer.server.Request(l_sPlayer.id + " album ?", function(response){
         var text = IR.UrlDecode(response);
         if(text != "")
            l_sAlbum.Text = text;
      });
      // Позиция в плейлисте
      var l_si = l_sPlaylist.ItemsCount;
      for (var i = 0; i < l_si; i++) {
         l_sPlaylist.CreateItem(i, 0, {FillColor: in_gui.l_sPlaylistCol0});
      }
      if(l_sCurrent !== undefined)  {
         l_sPlaylist.CreateItem(l_sCurrent, 0, {FillColor: in_gui.l_sPlaylistCol1}); 
         l_sArt.GetState(0).Image = url + "current/cover256x256?player=" + l_sPlayer.id;
      }
      IR.SetTimeout(100, function(){
         if (l_sAbdate) {
            if ((l_sPlaylist.ItemsCount - l_sCurrent) >11)
               l_sPlaylist.SetPosition(l_sCurrent);
            else if ((l_sCurrent - 11) < 0) 
               l_sPlaylist.SetPosition(0);
            else               
               l_sPlaylist.SetPosition(l_sCurrent - 11);
         }
         });  
         //}
      }
      //Выбор плеера
      function SelectPlayer(index){
         l_sLastplayer = index;
         IR.SetVariable("Global.SqueezeboxLastPlayer", l_sLastplayer);
         // Отменяем предыдущую подписку
         if(l_sPlayer)
            l_sPlayer.server.Unsubscribe(l_sPlayer.id + " status 0 500 tags%3Aac");
         l_sPlayer = l_sPlayers[index];
         GetItem(in_gui.l_sZone).Text = l_sPlayer.name;
         // Подписываемся на изменения статуса
         l_sPlayer.server.Subscribe(l_sPlayer.id + " status 0 500 tags%3Aac", UpdatePlayer);
         // Обновляем контент
         UpdateContent("musicfolder");         
      }
      // Выбор плеера
      function SelectPlayerId(id){
         id = id.replace(/:/g, "%3A");
         // Ищем нужный плеер
         for(var i = 0; i < l_sPlayers.length; ++i) {
            if(l_sPlayers[i].id == id) {
               SelectPlayer(i); 
               break;
            }
         }
      }
      // Обновить список серверов
      function UpdateServers(){
         l_sServersList.Clear();
         for(var i = 0; i < l_sServers.length; ++i){
            l_sServersList.CreateItem(i, 3, {Text: l_sServers[i].host});
         }
      }
      // Обновить список содержимого
      function UpdateContent(ntype, l_sFilter){
         l_sType = ntype;   
         l_sFolder.Text = l_sMap[l_sType].name;
         // Попап поиска
         if(ntype == "search")
            IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sSearch);
         else
            IR.HidePopup(in_gui.l_sSearch);
         // Запоминаем историю команд
         l_sHistory.push({"type": l_sType, "filter": l_sFilter});
         var visible = (l_sHistory.length > 1);
         l_sBack.Visible = l_sBack.Enable = visible;
         l_sContenticon.Visible = l_sContenticon.Enable = !visible;
         // Очистим список
         l_sList.Clear();
         l_sContent.length = 0;
         // Сбрасываем фильтр
         GetItem(in_gui.l_sFilter).Text = "";
         l_sList.l_sFilter = "";
         // Кнопка удаления
         l_sRemove.Visible = l_sRemove.Enable = false;
         // Отключаем все буквы поиска
         for(var i = 65; i < 91; i++)
            l_sLetters[i].Enable = false;      
         // Формируем строку запроса
         var command = l_sMap[l_sType].command + " 0 100";
         if(l_sFilter)
            command += " " + l_sFilter;
            if(l_sMap[l_sType].tags)
               command += " tags%3A" + l_sMap[l_sType].tags;
               // Запрос к базе
            switch(l_sType){
            case "browse":
               IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sWaitLeft);
               command = l_sPlayer.id + ' ' + l_sPlugin + command;
               l_sPlayer.server.Request(command, BrowseCallback);
               break;
            case "search":
               for(var i = 1; i < l_sSearch.length; ++i){
                  l_sList.CreateItem(i, 2, {Text: l_sMap[l_sSearch[i]].name});
                  l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});  
                  l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
               }
               break;
            case "favorit":
               IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sWaitLeft);
               l_sRemove.Visible = l_sRemove.Enable = true;
               l_sPlayer.server.Request(command, BrowseCallback);
               break;
           case "playlist":
               IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sWaitLeft);
               l_sRemove.Visible = l_sRemove.Enable = true;
               l_sPlayer.server.Request(command, UpdateContentCallback);               
               break;
           case "random":
               for(var i = 1; i < l_sRandom.length; ++i){
                  l_sList.CreateItem(i, 2, {Text: l_sRandom[i].name});
                  l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
               }
               var choose = GetItem(in_gui.l_sChoosegenres);
               choose.Visible = choose.Enable = true;
               break;
           case "randomgenre":
               IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sWaitLeft);
               command = l_sPlayer.id + ' ' + command;
               l_sPlayer.server.Request(command, ChooseGenreCallback);
               break;
            default:
               IR.GetItem(in_gui.l_sMain_page).ShowPopup(in_gui.l_sWaitLeft);
               l_sPlayer.server.Request(command, UpdateContentCallback);
               break;
            }
      }  
      // Получение списка содержимого
      function UpdateContentCallback(response, request){
         var param, total, i, text, letter, code, last, pos, key, value;
		 var l_sName = "Any is breaked";
         var id, l_sArtist, name;
         var url = "http://" + l_sPlayer.server.host + ":" + in_gui.covers_port + "/music/";   
         i = l_sContent.length - 1;
         response = response.split(' ');
         while(param = response.shift()){
            pos = param.indexOf("%3A");
            key = param.substring(0, pos);
            value = param.substring(pos+3);  	
         switch(key){
         case "id":
            id = value;
            break;
         case "artist":
            l_sArtist = IR.UrlDecode(value); 
            if(l_sType == "artist"){
               /*
               //Буква поиска
               letter = l_sArtist.charAt(0).toUpperCase();
               code = letter.charCodeAt(0);
               if(last != code && code >= 65 && code < 91)
               {
                  l_sContent[++i] = 0;
                  l_sLetters[code].Enable = true;
                  l_sLetters[code].id = i;
                  last = code;
                  l_sList.CreateItem(i, 0, {Name: letter});
                  l_sList.CreateItem(i, 6, {Visible: true, Enable: true, Text: letter});
                  l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
               }  */
               // Элемент
               l_sContent[++i] = {id: id, name: value};
               l_sList.CreateItem(i, 2, {Text: l_sArtist});
               l_sList.CreateItem(i, 0, {Name: l_sArtist.toLowerCase()});
               l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});               
            } 
            else 
               l_sList.CreateItem(i, 3, {Text: l_sArtist});
               break;
            case "album":
               if(l_sType == "album"){
                  text = IR.UrlDecode(value);
                  /*
                  // Буква поиска
                  letter = text.charAt(0).toUpperCase();
                  code = letter.charCodeAt(0);
                  if(last != code && code >= 65 && code < 91)
                  {
                     l_sContent[++i] = 0;
                     letters[code].Enable = true;
                     letters[code].id = i;
                     l_sList = code;
                     l_sList.CreateItem(i, 6, {Visible: true, Enable: true, Text: letter});
                     l_sList.CreateItem(i, 0, {Name: letter});
                     l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
                  }
                  */
                  // Элемент 
                  l_sContent[++i] = {id: id, name: value};  
                  l_sList.CreateItem(i, 2, {Text: text});
                  l_sList.CreateItem(i, 0, {Name: text.toLowerCase()});
                  l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});
               }
               break;
            case "genre":
               l_sList.CreateItem(i+1, 4, {Image: in_gui.l_sImgFolder});
            case "title":
               text = IR.UrlDecode(value);
               l_sContent[++i] = {id: id, name: value};
               l_sList.CreateItem(i, 2, {Text: text});
               l_sList.CreateItem(i, 0, {Name: text.toLowerCase()});
               break;
            case "year":
               l_sContent[++i] = {id: value, name: value};
               l_sList.CreateItem(i, 2, {Text: value});
               l_sList.CreateItem(i, 0, {Name: value});
               l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});
               break;
            case "filename":
					l_sName = value;
					text = IR.UrlDecode(value);
               break;
			case "type":
					l_sContent[++i] = {id: id, name: l_sName, type: value};
					l_sList.CreateItem(i, 2, {Text: text});
					l_sList.CreateItem(i, 2, {Text: l_sName});
					l_sList.CreateItem(i, 6, {Visible: false});
					switch(value){
						   case "folder":
								l_sList.CreateItem(i, 4, {Image: "Folder.png"});
							break;
							case "track":
								l_sList.CreateItem(i, 4, {Image: "Songs.png"});
							break;
							case "playlist":
								l_sList.CreateItem(i, 4, {Image: "Playlists_50_Squeezebox.png"});
							break;
						 }
            break;
            case "playlist":
               text = IR.UrlDecode(value);
               l_sContent[++i] = {id: id, name: value};
               l_sList.CreateItem(i, 2, {Text: text});
               l_sList.CreateItem(i, 0, {Name: text.toLowerCase()});
               l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});
               break;            
            case "artwork_track_id":
            case "coverid":
               l_sList.CreateItem(i, 4, {Image: url + value + "/cover64x64"});
               break;
            case "cmd":
               id = value;
               break;
            case "name":
               name = IR.UrlDecode(value);
			   l_sName = name;			   
               break;
            case "l_sType":
               if(value == "xmlbrowser"){
                  l_sContent[++i] = id;
                  l_sList.CreateItem(i, 2, {Text: name});
                  l_sList.CreateItem(i, 0, {Name: name.toLowerCase()});
                  l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});
                  l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
               }
               break;
               break;                        
            case "count":
               total = value;
               break;
            }
         }
         // Сколько осталось
         request = request.split(' ');
         var start = parseInt(request[1]) + parseInt(request[2]);
         // если поиск не дал результатов, создаем элемент на который нельзя нажать
         if(total == 0){
            l_sList.CreateItem(0, 2, {Text: "... Nothing finded ..."});
            l_sList.CreateItem(0, 1, {Enable: false});
            l_sList.CreateItem(0, 0, {Enable: false});
            l_sList.CreateItem(0, 4, {Visible: false, Enable: false});
            l_sList.CreateItem(0, 5, {Visible: false, Enable: false});
         }
         else{
         // позиционируем список
         if(l_sPostioning == true){
            IR.SetTimeout(200, SetPosition);
         }
         }
         if(start < total){
         // Создадим пустые элементы
          for(var need = total - l_sList.ItemsCount; need > 0; --need)
            l_sList.CreateItem(++i, 2, {}); 
            // Запрашиваем остальное
            request[1] = start;
            l_sPlayer.server.Request(request.join(' '), UpdateContentCallback);   
         } 
         else {
         IR.HidePopup(in_gui.l_sWaitLeft);
         }
      }
      // Получение списка содержимого (browse)
      function BrowseCallback(response, request){
         var param, total, i, id, name, audio, pos, key, value, url;
         i = l_sContent.length - 1;
         response = response.split(' ');			
         while(param = response.shift()){
            pos = param.indexOf("%3A");
            key = param.substring(0, pos);
            value = param.substring(pos+3);
         switch(key){
         case "id":
            id = value;
            break;
         case "title":
         case "name":
            name = value;
            break;
         case "l_sType":
            break;            
         case "isaudio":
            audio = value;
            break;
         case "url":
            url = value;
            break;
         case "hasitems":
            l_sContent[++i] = {id: id, audio: audio, url: url, name: name};
            name = IR.UrlDecode(name);
            l_sList.CreateItem(i, 2, {Text: name});
            l_sList.CreateItem(i, 0, {Name: name});
            if(value == 1 && audio == 0){
               l_sList.CreateItem(i, 4, {Image: in_gui.l_sImgFolder});
               l_sList.CreateItem(i, 5, {Visible: false, Enable: false});
            } 
            break;
         case "count":
            total = value;
            break;
         }
         }
         // если поиск не дал результатов, создаем элемент на который нельзя нажать
         if(total == 0){
            l_sList.CreateItem(0, 2, {Text: "... Nothing finded ..."});
            l_sList.CreateItem(0, 1, {Enable: false});
            l_sList.CreateItem(0, 0, {Enable: false});
            l_sList.CreateItem(0, 4, {Visible: false, Enable: false});
            l_sList.CreateItem(0, 5, {Visible: false, Enable: false}); 
         } 
         else{
            // позиционируем список
            if(l_sPostioning == true){
            IR.SetTimeout(200, SetPosition);
            }
         }
         // Сколько осталось
         request = request.split(' ');
         var start = parseInt(request[1]) + parseInt(request[2]);
         if(start < total){
            // Создадим пустые элементы
             for(var need = total - l_sList.ItemsCount; need > 0; --need)
               l_sList.CreateItem(++i, 2, {}); 
               // Запрашиваем остальное
               request[1] = start;
               l_sPlayer.server.Request(request.join(' '), BrowseCallback);   
         } 
         else {
            IR.HidePopup(in_gui.l_sWaitLeft);
         }
      
      }   
      // Получение списка содержимого (choose genre)
      function ChooseGenreCallback(response, request){
         var param, i, name, pos, key, value, check;
         i = 0;
         response = response.split(' ');			
         while(param = response.shift()){
            pos = param.indexOf("%3A");
            key = param.substring(0, pos);
            value = param.substring(pos+3);
         switch(key){
         case "nextWindow":
            check = undefined;
            break;
         case "checkbox":
            check = value;
            break;
         case "text":
            if(check != undefined){
               name = IR.UrlDecode(value);
               l_sContent[++i] = value;
               l_sList.CreateItem(i, 2, {Text: name});
               l_sList.CreateItem(i, 0, {Name: name, FillColor: ((check == 1) ? in_gui.l_sContentCol1 : in_gui.l_sContentCol0)});
               l_sList.CreateItem(i, 5, {Value: check});
               l_sSelect[i] = check;
            }
            break;
         }
         }
         IR.HidePopup(in_gui.l_sWaitLeft);
      }      
      // Добавить выделенные в плейлист
      function AddToPlaylist(cmd){
		  
         var command = l_sPlayer.id + " playlistcontrol cmd%3A" + cmd;
         for(var i = 0; i < l_sSelect.length; ++i){
            if(l_sSelect[i]){
               // TODO заменить switch на map	  
            switch(l_sType){
            case "artist":
               l_sPlayer.server.Request(command + " artist_id%3A" + l_sContent[i].id);
               break;
            case "album":
               l_sPlayer.server.Request(command + " album_id%3A" + l_sContent[i].id);
               break;
            case "musicfolder"://IR.Log(JSON.Stringify(l_sContent[i])); 
               switch(l_sContent[i].type){
				case "track":
				   l_sPlayer.server.Request("playlistcontrol cmd%3A" + cmd + " track_id%3A" + l_sContent[i].id);
				   break;
				case "folder":
				   l_sPlayer.server.Request("playlistcontrol cmd%3A" + cmd + " folder_id%3A" + l_sContent[i].id);
				   break;
				case "playlist":
				   l_sPlayer.server.Request("playlistcontrol cmd%3A" + cmd + " playlist_id%3A" + l_sContent[i].id);
				   break;   
			   }
               break;
            case "genre":
               l_sPlayer.server.Request(command + " genre_id%3A" + l_sContent[i].id);
               break;
            case "year":
               l_sPlayer.server.Request(command + " year%3A" + l_sContent[i].id);
               break;
            case "title":
               l_sPlayer.server.Request(command + " track_id%3A" + l_sContent[i].id);
               break;
            case "playlist":
               l_sPlayer.server.Request(command + " playlist_id%3A" + l_sContent[i].id);
               break;
            case "pltrack":
               l_sPlayer.server.Request(command + " track_id%3A" + l_sContent[i].id);
               break;
            case "favorit":
               l_sPlayer.server.Request(l_sPlayer.id + " favorites playlist " + cmd + " item_id%3A"+ l_sContent[i].id);
               break;               
            case "browse":
               l_sPlayer.server.Request(l_sPlayer.id + ' ' + l_sPlugin + " playlist " + cmd + " item_id%3A"+ l_sContent[i].id);
               break;
            }      
            // Снимем выделение
            l_sList.CreateItem(i, 0, {FillColor: in_gui.l_sContentCol0});
            l_sList.CreateItem(i, 5, {Value: 0});                  
            }
         }
         l_sSelect.length = 0;
      } 
      // Добавить выделенные в избранное
      function AddToFavorites(){
         var command = "favorites add title%3A";
         var favText = GetItem(in_gui.l_sFavoritesText1);
         for(var i = 0; i < l_sSelect.length; ++i){
            if(l_sSelect[i]){
            switch(l_sType){
            case "artist":
               l_sPlayer.server.Request(command + l_sContent[i].name + " url%3Adb%3Acontributor.id%3D" + l_sContent[i].id);
               break;
            case "album":
               l_sPlayer.server.Request(command + l_sContent[i].name + " url%3Adb%3Aalbum.id%3D" + l_sContent[i].id);
               break;
            case "genre":
               l_sPlayer.server.Request(command + l_sContent[i].name + " url%3Adb%3Agenre.id%3D" + l_sContent[i].id);
               break;
            case "year":
               l_sPlayer.server.Request(command + l_sContent[i].name + " url%3Adb%3Ayear.id%3D" + l_sContent[i].id);
               break;
            case "title":
               l_sPlayer.server.Request(command + TranslitRusString(IR.UrlDecode(l_sContent[i].name)) + " url%3Adb%3Atrack.id%3D" + l_sContent[i].id);
               break;
            case "browse":
               l_sPlayer.server.Request(command + l_sContent[i].name + " url%3A" + l_sContent[i].id);
               //l_sPlayer.server.Request("favorites items 0 100 item_id%3A" + l_sContent[i].id + " want_url%3A1");
               //l_sPlayer.server.Request(l_sPlayer.id + ' ' + l_sPlugin + " items 0 100 item_id%3A"+ l_sContent[i].id + " want_url%3A1");
               break;
            }
            // Надпись при добавлении
            favText.Text = IR.UrlDecode(l_sContent[i].name);
            // Снимем выделение
            l_sList.CreateItem(i, 0, {FillColor: in_gui.l_sContentCol0});
            l_sList.CreateItem(i, 5, {Value: 0});                  
            
            }
         }
         l_sSelect.length = 0;
      } 
      // Удалить выделенные из избранного
      function DeleteFromFavorites(){
         var id, command = "favorites delete item_id%3A";
         for(var i = l_sSelect.length; i--;){
            if(l_sSelect[i]){
               id = l_sContent[i].id;
               id = id.substr(id.indexOf('.') + 1);
               l_sPlayer.server.Request(command + id);
            }
         }
         l_sSelect.length = 0;
         IR.SetTimeout(500, function() {
         l_sHistory = [];
         UpdateContent("favorit");
         });
      }
      // Удалить выделенные плейлисты
      function DeletePlaylists(){
         var command = "playlists delete playlist_id%3A";
         for(var i = l_sSelect.length; i--;){
            if(l_sSelect[i])
               l_sPlayer.server.Request(command + l_sContent[i].id);
         }
         l_sSelect.length = 0;
         IR.SetTimeout(500, function() {
            l_sHistory = [];
            UpdateContent("playlist");
         });
      }
      function time(in_sValue){
         if (in_sValue){
            var l_nHoursTime = Math.round(in_sValue) / 3600;
            var l_sHoursFixedTime = l_nHoursTime.toFixed(2);
            var l_nFloatTime = Math.round(in_sValue) / 60;
   			var l_sFloatFixedTime = l_nFloatTime.toFixed(2);
   			var l_nFloatParsedTime = Math.round(l_sFloatFixedTime.split(".")[1]) * 0.6;
   			var l_sTime = Math.round(l_nFloatParsedTime);
            var l_sEndTime =l_sHoursFixedTime.split(".")[0];
			if (parseInt(l_sFloatFixedTime.split(".")[0]) < 10) {
            l_sEndTime += ":0" + l_sFloatFixedTime.split(".")[0]
			} else l_sEndTime += ":" + l_sFloatFixedTime.split(".")[0]
         if (l_sTime < 10) {
				l_sTime = ":0" + l_sTime;
            l_sEndTime += l_sTime
			} else
				l_sEndTime += ":" + l_sTime;
		    return l_sEndTime;
         } else
			return "";
	   }       
      IR.SetInterval(1000, function(){
         if (l_sPlay.Value){
            l_sPosition += 1;
            l_sTimeline.Value = (l_sPosition / l_sDuration) * 100; 
            var l_nElapsed = l_sDuration - l_sPosition;
            l_sTimeright.Text = time(l_sPosition);
            l_sTimeleft.Text = "-" + time(l_nElapsed);
         }
      });
      // Загрузка серверов
      function LoadServers(){
         l_sPlayer = undefined;
         //l_sServers.length = 0;
         l_sLastplayer = IR.GetVariable("Global.SqueezeboxLastPlayer") | 0;
         var value = 0;
         if(in_gui.l_sServers.length > 0)
            value = in_gui.l_sServers.join(",");
         else 
            value = IR.GetVariable("Global.SqueezeboxServers");
            if(value){
               var hosts = value.split(',');
               for(var i = 0; i < hosts.length; ++i){
                  var sbox = new SqueezeBox(hosts[i]);
                  sbox.Online = Online;
                  sbox.Offline = Offline;
                  l_sServers.push(sbox);
                  sbox.Connect();
               }
            }      
      }
      // Сохранить список серверов
      function SaveServers(){
         var value = l_sServers.length ? l_sServers[0].host : "";
         for(var i = 1; i < l_sServers.length; ++i)
            value += ',' + l_sServers[i].host;
            IR.SetVariable("Global.SqueezeboxServers", value);
      }
      // Событие: Соединение с сервером
      function Online(){
         UpdatePlayers();
      }   
      // Событие: Потеря соединения с сервером
      function Offline(){
         l_sClear();
         UpdatePlayers();
      }      
      // Очистка интерфейса
      function Clear(){
         l_sPlay.Value = 0;
         l_sList.Clear();
         l_sList.Filter = "";      
         l_sPlaylist.Clear();
         //l_sTimeline.Value = 0;
         l_sTimeleft.Text = "";
         l_sArtist.Text = "";
         l_sAlbum.Text = "";
         l_sTrack.Text = "";
         l_sArt.GetState(0).Image = "";
         GetItem(in_gui.l_sZone).Text = "";
         l_sPercent.Text = "0%";
         l_sVolume.Value  = 0;
      }         
      // Find ui item
      function GetItem(path){
         path = path.split('.');
         // Find parent
         var parent = IR.GetItem(path[0]);
         // Find child
         return parent.GetItem(path[1]);
      }
      //Смещает лист на предыдущую позицию после обработки кэша
      function SetPosition(){
       //  IR.Log("SetPosition " + l_sPrevListItem + " " + l_sListItemsCount);
         if(l_sPrevListItem >= l_sListItemsCount){
            // возвращаемся на последнюю позицию
            var item_count = l_sList.ItemsCount - l_sListItemsCount;
            var index = (l_sPrevListItem > item_count) ? item_count : l_sPrevListItem;
           // IR.Log("Index: " + index + " item_count " + item_count);
            l_sList.SetPosition(index);
            l_sPrevListItem = -1;
         }
      }
      
};